RFC3447 = {'PKCS-1': {'extensibility-implied': False,
            'imports': {'NIST-SHA2': ['id-sha256', 'id-sha384', 'id-sha512']},
            'object-classes': {'ALGORITHM-IDENTIFIER': {'members': [{'name': '&id',
                                                                     'optional': False,
                                                                     'type': 'OBJECT IDENTIFIER'},
                                                                    {'name': '&Type',
                                                                     'optional': False,
                                                                     'type': 'OpenType'}]}},
            'object-sets': {'OAEP-PSSDigestAlgorithms': {'class': 'ALGORITHM-IDENTIFIER',
                                                         'members': []},
                            'PKCS1-v1-5DigestAlgorithms': {'class': 'ALGORITHM-IDENTIFIER',
                                                           'members': []},
                            'PKCS1Algorithms': {'class': 'ALGORITHM-IDENTIFIER',
                                                'members': []},
                            'PKCS1MGFAlgorithms': {'class': 'ALGORITHM-IDENTIFIER',
                                                   'members': []},
                            'PKCS1PSourceAlgorithms': {'class': 'ALGORITHM-IDENTIFIER',
                                                       'members': []}},
            'tags': 'EXPLICIT',
            'types': {'AlgorithmIdentifier': {'members': [{'name': 'algorithm',
                                                           'optional': False,
                                                           'table': 'InfoObjectSet',
                                                           'type': 'ALGORITHM-IDENTIFIER.&id'},
                                                          {'name': 'parameters',
                                                           'optional': True,
                                                           'table': ['InfoObjectSet',
                                                                     ['.algorithm']],
                                                           'type': 'ALGORITHM-IDENTIFIER.&Type'}],
                                              'type': 'SEQUENCE'},
                      'DigestAlgorithm': {'type': 'AlgorithmIdentifier'},
                      'DigestInfo': {'members': [{'name': 'digestAlgorithm',
                                                  'optional': False,
                                                  'type': 'DigestAlgorithm'},
                                                 {'name': 'digest',
                                                  'optional': False,
                                                  'size': None,
                                                  'type': 'OCTET STRING'}],
                                     'type': 'SEQUENCE'},
                      'EncodingParameters': {'size': [(0, 'MAX')],
                                             'type': 'OCTET STRING'},
                      'HashAlgorithm': {'type': 'AlgorithmIdentifier'},
                      'MaskGenAlgorithm': {'type': 'AlgorithmIdentifier'},
                      'OtherPrimeInfo': {'members': [{'name': 'prime',
                                                      'optional': False,
                                                      'type': 'INTEGER'},
                                                     {'name': 'exponent',
                                                      'optional': False,
                                                      'type': 'INTEGER'},
                                                     {'name': 'coefficient',
                                                      'optional': False,
                                                      'type': 'INTEGER'}],
                                         'type': 'SEQUENCE'},
                      'OtherPrimeInfos': {'element': {'type': 'OtherPrimeInfo'},
                                          'size': [(1, 'MAX')],
                                          'type': 'SEQUENCE OF'},
                      'PSourceAlgorithm': {'type': 'AlgorithmIdentifier'},
                      'RSAES-AlgorithmIdentifier': {'type': 'AlgorithmIdentifier'},
                      'RSAES-OAEP-params': {'members': [{'default': 'sha1',
                                                         'name': 'hashAlgorithm',
                                                         'optional': False,
                                                         'tag': {'number': 0},
                                                         'type': 'HashAlgorithm'},
                                                        {'default': 'mgf1SHA1',
                                                         'name': 'maskGenAlgorithm',
                                                         'optional': False,
                                                         'tag': {'number': 1},
                                                         'type': 'MaskGenAlgorithm'},
                                                        {'default': 'pSpecifiedEmpty',
                                                         'name': 'pSourceAlgorithm',
                                                         'optional': False,
                                                         'tag': {'number': 2},
                                                         'type': 'PSourceAlgorithm'}],
                                            'type': 'SEQUENCE'},
                      'RSAPrivateKey': {'members': [{'name': 'version',
                                                     'optional': False,
                                                     'type': 'Version'},
                                                    {'name': 'modulus',
                                                     'optional': False,
                                                     'type': 'INTEGER'},
                                                    {'name': 'publicExponent',
                                                     'optional': False,
                                                     'type': 'INTEGER'},
                                                    {'name': 'privateExponent',
                                                     'optional': False,
                                                     'type': 'INTEGER'},
                                                    {'name': 'prime1',
                                                     'optional': False,
                                                     'type': 'INTEGER'},
                                                    {'name': 'prime2',
                                                     'optional': False,
                                                     'type': 'INTEGER'},
                                                    {'name': 'exponent1',
                                                     'optional': False,
                                                     'type': 'INTEGER'},
                                                    {'name': 'exponent2',
                                                     'optional': False,
                                                     'type': 'INTEGER'},
                                                    {'name': 'coefficient',
                                                     'optional': False,
                                                     'type': 'INTEGER'},
                                                    {'name': 'otherPrimeInfos',
                                                     'optional': True,
                                                     'type': 'OtherPrimeInfos'}],
                                        'type': 'SEQUENCE'},
                      'RSAPublicKey': {'members': [{'name': 'modulus',
                                                    'optional': False,
                                                    'type': 'INTEGER'},
                                                   {'name': 'publicExponent',
                                                    'optional': False,
                                                    'type': 'INTEGER'}],
                                       'type': 'SEQUENCE'},
                      'RSASSA-AlgorithmIdentifier': {'type': 'AlgorithmIdentifier'},
                      'RSASSA-PSS-params': {'members': [{'default': 'sha1',
                                                         'name': 'hashAlgorithm',
                                                         'optional': False,
                                                         'tag': {'number': 0},
                                                         'type': 'HashAlgorithm'},
                                                        {'default': 'mgf1SHA1',
                                                         'name': 'maskGenAlgorithm',
                                                         'optional': False,
                                                         'tag': {'number': 1},
                                                         'type': 'MaskGenAlgorithm'},
                                                        {'default': 20,
                                                         'name': 'saltLength',
                                                         'optional': False,
                                                         'tag': {'number': 2},
                                                         'type': 'INTEGER'},
                                                        {'default': 'trailerFieldBC',
                                                         'name': 'trailerField',
                                                         'optional': False,
                                                         'tag': {'number': 3},
                                                         'type': 'TrailerField'}],
                                            'type': 'SEQUENCE'},
                      'SHA1Parameters': {'type': 'NULL'},
                      'TrailerField': {'type': 'INTEGER'},
                      'Version': {'restricted-to': ['{', '}'],
                                  'type': 'INTEGER'}},
            'values': {'emptyString': {'type': 'EncodingParameters',
                                       'value': ["''H"]},
                       'id-RSAES-OAEP': {'type': 'OBJECT IDENTIFIER',
                                         'value': ['pkcs-1', 7]},
                       'id-RSASSA-PSS': {'type': 'OBJECT IDENTIFIER',
                                         'value': ['pkcs-1', 10]},
                       'id-md2': {'type': 'OBJECT IDENTIFIER',
                                  'value': [('iso', 1),
                                            ('member-body', 2),
                                            ('us', 840),
                                            ('rsadsi', 113549),
                                            ('digestAlgorithm', 2),
                                            2]},
                       'id-md5': {'type': 'OBJECT IDENTIFIER',
                                  'value': [('iso', 1),
                                            ('member-body', 2),
                                            ('us', 840),
                                            ('rsadsi', 113549),
                                            ('digestAlgorithm', 2),
                                            5]},
                       'id-mgf1': {'type': 'OBJECT IDENTIFIER',
                                   'value': ['pkcs-1', 8]},
                       'id-pSpecified': {'type': 'OBJECT IDENTIFIER',
                                         'value': ['pkcs-1', 9]},
                       'id-sha1': {'type': 'OBJECT IDENTIFIER',
                                   'value': [('iso', 1),
                                             ('identified-organization',
                                              3),
                                             ('oiw', 14),
                                             ('secsig', 3),
                                             ('algorithms', 2),
                                             26]},
                       'md2WithRSAEncryption': {'type': 'OBJECT IDENTIFIER',
                                                'value': ['pkcs-1', 2]},
                       'md5WithRSAEncryption': {'type': 'OBJECT IDENTIFIER',
                                                'value': ['pkcs-1', 4]},
                       'mgf1SHA1': {'type': 'MaskGenAlgorithm',
                                    'value': ['{',
                                              'algorithm',
                                              ['id-mgf1'],
                                              'parameters',
                                              [['HashAlgorithm', []],
                                               ':',
                                               ['sha1']],
                                              '}']},
                       'pSpecifiedEmpty': {'type': 'PSourceAlgorithm',
                                           'value': ['{',
                                                     'algorithm',
                                                     ['id-pSpecified'],
                                                     'parameters',
                                                     [['EncodingParameters', []],
                                                      ':',
                                                      ['emptyString']],
                                                     '}']},
                       'pkcs-1': {'type': 'OBJECT IDENTIFIER',
                                  'value': [('iso', 1),
                                            ('member-body', 2),
                                            ('us', 840),
                                            ('rsadsi', 113549),
                                            ('pkcs', 1),
                                            1]},
                       'rSAES-OAEP-Default-Identifier': {'type': 'RSAES-AlgorithmIdentifier',
                                                         'value': ['{',
                                                                   'algorithm',
                                                                   ['id-RSAES-OAEP'],
                                                                   'parameters',
                                                                   [['RSAES-OAEP-params',
                                                                     []],
                                                                    ':',
                                                                    ['{',
                                                                     'hashAlgorithm',
                                                                     ['sha1'],
                                                                     'maskGenAlgorithm',
                                                                     ['mgf1SHA1'],
                                                                     'pSourceAlgorithm',
                                                                     ['pSpecifiedEmpty'],
                                                                     '}']],
                                                                   '}']},
                       'rSASSA-PSS-Default-Identifier': {'type': 'RSASSA-AlgorithmIdentifier',
                                                         'value': ['{',
                                                                   'algorithm',
                                                                   ['id-RSASSA-PSS'],
                                                                   'parameters',
                                                                   [['RSASSA-PSS-params',
                                                                     []],
                                                                    ':',
                                                                    ['{',
                                                                     'hashAlgorithm',
                                                                     ['sha1'],
                                                                     'maskGenAlgorithm',
                                                                     ['mgf1SHA1'],
                                                                     'saltLength',
                                                                     ['20'],
                                                                     'trailerField',
                                                                     ['trailerFieldBC'],
                                                                     '}']],
                                                                   '}']},
                       'rsaEncryption': {'type': 'OBJECT IDENTIFIER',
                                         'value': ['pkcs-1', 1]},
                       'sha1': {'type': 'HashAlgorithm',
                                'value': ['{',
                                          'algorithm',
                                          ['id-sha1'],
                                          'parameters',
                                          [['SHA1Parameters', []],
                                           ':',
                                           ['NULL']],
                                          '}']},
                       'sha1WithRSAEncryption': {'type': 'OBJECT IDENTIFIER',
                                                 'value': ['pkcs-1', 5]},
                       'sha256WithRSAEncryption': {'type': 'OBJECT IDENTIFIER',
                                                   'value': ['pkcs-1', 11]},
                       'sha384WithRSAEncryption': {'type': 'OBJECT IDENTIFIER',
                                                   'value': ['pkcs-1', 12]},
                       'sha512WithRSAEncryption': {'type': 'OBJECT IDENTIFIER',
                                                   'value': ['pkcs-1', 13]}}}}
