RFC4211 = {'PKIXCRMF-2005': {'extensibility-implied': False,
                   'imports': {'CryptographicMessageSyntax2004': ['EnvelopedData'],
                               'PKIX1Explicit88': ['Version',
                                                   'AlgorithmIdentifier',
                                                   'Name',
                                                   'Time',
                                                   'SubjectPublicKeyInfo',
                                                   'Extensions',
                                                   'UniqueIdentifier',
                                                   'Attribute'],
                               'PKIX1Implicit88': ['GeneralName']},
                   'object-classes': {},
                   'object-sets': {},
                   'tags': 'IMPLICIT',
                   'types': {'AttributeTypeAndValue': {'members': [{'name': 'type',
                                                                    'optional': False,
                                                                    'type': 'OBJECT IDENTIFIER'},
                                                                   {'choices': {},
                                                                    'name': 'value',
                                                                    'optional': False,
                                                                    'type': 'ANY DEFINED BY',
                                                                    'value': 'type'}],
                                                       'type': 'SEQUENCE'},
                             'Attributes': {'element': {'type': 'Attribute'},
                                            'size': None,
                                            'type': 'SET OF'},
                             'Authenticator': {'type': 'UTF8String'},
                             'CertId': {'members': [{'name': 'issuer',
                                                     'optional': False,
                                                     'type': 'GeneralName'},
                                                    {'name': 'serialNumber',
                                                     'optional': False,
                                                     'type': 'INTEGER'}],
                                        'type': 'SEQUENCE'},
                             'CertReq': {'type': 'CertRequest'},
                             'CertReqMessages': {'element': {'type': 'CertReqMsg'},
                                                 'size': [(1, 'MAX')],
                                                 'type': 'SEQUENCE OF'},
                             'CertReqMsg': {'members': [{'name': 'certReq',
                                                         'optional': False,
                                                         'type': 'CertRequest'},
                                                        {'name': 'popo',
                                                         'optional': True,
                                                         'type': 'ProofOfPossession'},
                                                        {'element': {'type': 'AttributeTypeAndValue'},
                                                         'name': 'regInfo',
                                                         'optional': True,
                                                         'size': [(1,
                                                                   'MAX')],
                                                         'type': 'SEQUENCE OF'}],
                                            'type': 'SEQUENCE'},
                             'CertRequest': {'members': [{'name': 'certReqId',
                                                          'optional': False,
                                                          'type': 'INTEGER'},
                                                         {'name': 'certTemplate',
                                                          'optional': False,
                                                          'type': 'CertTemplate'},
                                                         {'name': 'controls',
                                                          'optional': True,
                                                          'type': 'Controls'}],
                                             'type': 'SEQUENCE'},
                             'CertTemplate': {'members': [{'name': 'version',
                                                           'optional': True,
                                                           'tag': {'number': 0},
                                                           'type': 'Version'},
                                                          {'name': 'serialNumber',
                                                           'optional': True,
                                                           'tag': {'number': 1},
                                                           'type': 'INTEGER'},
                                                          {'name': 'signingAlg',
                                                           'optional': True,
                                                           'tag': {'number': 2},
                                                           'type': 'AlgorithmIdentifier'},
                                                          {'name': 'issuer',
                                                           'optional': True,
                                                           'tag': {'number': 3},
                                                           'type': 'Name'},
                                                          {'name': 'validity',
                                                           'optional': True,
                                                           'tag': {'number': 4},
                                                           'type': 'OptionalValidity'},
                                                          {'name': 'subject',
                                                           'optional': True,
                                                           'tag': {'number': 5},
                                                           'type': 'Name'},
                                                          {'name': 'publicKey',
                                                           'optional': True,
                                                           'tag': {'number': 6},
                                                           'type': 'SubjectPublicKeyInfo'},
                                                          {'name': 'issuerUID',
                                                           'optional': True,
                                                           'tag': {'number': 7},
                                                           'type': 'UniqueIdentifier'},
                                                          {'name': 'subjectUID',
                                                           'optional': True,
                                                           'tag': {'number': 8},
                                                           'type': 'UniqueIdentifier'},
                                                          {'name': 'extensions',
                                                           'optional': True,
                                                           'tag': {'number': 9},
                                                           'type': 'Extensions'}],
                                              'type': 'SEQUENCE'},
                             'Controls': {'element': {'type': 'AttributeTypeAndValue'},
                                          'size': [(1, 'MAX')],
                                          'type': 'SEQUENCE OF'},
                             'EncKeyWithID': {'members': [{'name': 'privateKey',
                                                           'optional': False,
                                                           'type': 'PrivateKeyInfo'},
                                                          {'members': [{'name': 'string',
                                                                        'optional': False,
                                                                        'type': 'UTF8String'},
                                                                       {'name': 'generalName',
                                                                        'optional': False,
                                                                        'type': 'GeneralName'}],
                                                           'name': 'identifier',
                                                           'optional': True,
                                                           'type': 'CHOICE'}],
                                              'type': 'SEQUENCE'},
                             'EncryptedKey': {'members': [{'name': 'encryptedValue',
                                                           'optional': False,
                                                           'type': 'EncryptedValue'},
                                                          {'name': 'envelopedData',
                                                           'optional': False,
                                                           'tag': {'number': 0},
                                                           'type': 'EnvelopedData'}],
                                              'type': 'CHOICE'},
                             'EncryptedValue': {'members': [{'name': 'intendedAlg',
                                                             'optional': True,
                                                             'tag': {'number': 0},
                                                             'type': 'AlgorithmIdentifier'},
                                                            {'name': 'symmAlg',
                                                             'optional': True,
                                                             'tag': {'number': 1},
                                                             'type': 'AlgorithmIdentifier'},
                                                            {'name': 'encSymmKey',
                                                             'optional': True,
                                                             'size': None,
                                                             'tag': {'number': 2},
                                                             'type': 'BIT STRING'},
                                                            {'name': 'keyAlg',
                                                             'optional': True,
                                                             'tag': {'number': 3},
                                                             'type': 'AlgorithmIdentifier'},
                                                            {'name': 'valueHint',
                                                             'optional': True,
                                                             'size': None,
                                                             'tag': {'number': 4},
                                                             'type': 'OCTET STRING'},
                                                            {'name': 'encValue',
                                                             'optional': False,
                                                             'size': None,
                                                             'type': 'BIT STRING'}],
                                                'type': 'SEQUENCE'},
                             'KeyGenParameters': {'size': None,
                                                  'type': 'OCTET STRING'},
                             'OldCertId': {'type': 'CertId'},
                             'OptionalValidity': {'members': [{'name': 'notBefore',
                                                               'optional': True,
                                                               'tag': {'number': 0},
                                                               'type': 'Time'},
                                                              {'name': 'notAfter',
                                                               'optional': True,
                                                               'tag': {'number': 1},
                                                               'type': 'Time'}],
                                                  'type': 'SEQUENCE'},
                             'PBMParameter': {'members': [{'name': 'salt',
                                                           'optional': False,
                                                           'size': None,
                                                           'type': 'OCTET STRING'},
                                                          {'name': 'owf',
                                                           'optional': False,
                                                           'type': 'AlgorithmIdentifier'},
                                                          {'name': 'iterationCount',
                                                           'optional': False,
                                                           'type': 'INTEGER'},
                                                          {'name': 'mac',
                                                           'optional': False,
                                                           'type': 'AlgorithmIdentifier'}],
                                              'type': 'SEQUENCE'},
                             'PKIArchiveOptions': {'members': [{'name': 'encryptedPrivKey',
                                                                'optional': False,
                                                                'tag': {'number': 0},
                                                                'type': 'EncryptedKey'},
                                                               {'name': 'keyGenParameters',
                                                                'optional': False,
                                                                'tag': {'number': 1},
                                                                'type': 'KeyGenParameters'},
                                                               {'name': 'archiveRemGenPrivKey',
                                                                'optional': False,
                                                                'tag': {'number': 2},
                                                                'type': 'BOOLEAN'}],
                                                   'type': 'CHOICE'},
                             'PKIPublicationInfo': {'members': [{'name': 'action',
                                                                 'optional': False,
                                                                 'type': 'INTEGER'},
                                                                {'element': {'type': 'SinglePubInfo'},
                                                                 'name': 'pubInfos',
                                                                 'optional': True,
                                                                 'size': [(1,
                                                                           'MAX')],
                                                                 'type': 'SEQUENCE OF'}],
                                                    'type': 'SEQUENCE'},
                             'PKMACValue': {'members': [{'name': 'algId',
                                                         'optional': False,
                                                         'type': 'AlgorithmIdentifier'},
                                                        {'name': 'value',
                                                         'optional': False,
                                                         'size': None,
                                                         'type': 'BIT STRING'}],
                                            'type': 'SEQUENCE'},
                             'POPOPrivKey': {'members': [{'name': 'thisMessage',
                                                          'optional': False,
                                                          'size': None,
                                                          'tag': {'number': 0},
                                                          'type': 'BIT STRING'},
                                                         {'name': 'subsequentMessage',
                                                          'optional': False,
                                                          'tag': {'number': 1},
                                                          'type': 'SubsequentMessage'},
                                                         {'name': 'dhMAC',
                                                          'optional': False,
                                                          'size': None,
                                                          'tag': {'number': 2},
                                                          'type': 'BIT STRING'},
                                                         {'name': 'agreeMAC',
                                                          'optional': False,
                                                          'tag': {'number': 3},
                                                          'type': 'PKMACValue'},
                                                         {'name': 'encryptedKey',
                                                          'optional': False,
                                                          'tag': {'number': 4},
                                                          'type': 'EnvelopedData'}],
                                             'type': 'CHOICE'},
                             'POPOSigningKey': {'members': [{'name': 'poposkInput',
                                                             'optional': True,
                                                             'tag': {'number': 0},
                                                             'type': 'POPOSigningKeyInput'},
                                                            {'name': 'algorithmIdentifier',
                                                             'optional': False,
                                                             'type': 'AlgorithmIdentifier'},
                                                            {'name': 'signature',
                                                             'optional': False,
                                                             'size': None,
                                                             'type': 'BIT STRING'}],
                                                'type': 'SEQUENCE'},
                             'POPOSigningKeyInput': {'members': [{'members': [{'name': 'sender',
                                                                               'optional': False,
                                                                               'tag': {'number': 0},
                                                                               'type': 'GeneralName'},
                                                                              {'name': 'publicKeyMAC',
                                                                               'optional': False,
                                                                               'type': 'PKMACValue'}],
                                                                  'name': 'authInfo',
                                                                  'optional': False,
                                                                  'type': 'CHOICE'},
                                                                 {'name': 'publicKey',
                                                                  'optional': False,
                                                                  'type': 'SubjectPublicKeyInfo'}],
                                                     'type': 'SEQUENCE'},
                             'PrivateKeyInfo': {'members': [{'name': 'version',
                                                             'optional': False,
                                                             'type': 'INTEGER'},
                                                            {'name': 'privateKeyAlgorithm',
                                                             'optional': False,
                                                             'type': 'AlgorithmIdentifier'},
                                                            {'name': 'privateKey',
                                                             'optional': False,
                                                             'size': None,
                                                             'type': 'OCTET STRING'},
                                                            {'name': 'attributes',
                                                             'optional': True,
                                                             'tag': {'kind': 'IMPLICIT',
                                                                     'number': 0},
                                                             'type': 'Attributes'}],
                                                'type': 'SEQUENCE'},
                             'ProofOfPossession': {'members': [{'name': 'raVerified',
                                                                'optional': False,
                                                                'tag': {'number': 0},
                                                                'type': 'NULL'},
                                                               {'name': 'signature',
                                                                'optional': False,
                                                                'tag': {'number': 1},
                                                                'type': 'POPOSigningKey'},
                                                               {'name': 'keyEncipherment',
                                                                'optional': False,
                                                                'tag': {'number': 2},
                                                                'type': 'POPOPrivKey'},
                                                               {'name': 'keyAgreement',
                                                                'optional': False,
                                                                'tag': {'number': 3},
                                                                'type': 'POPOPrivKey'}],
                                                   'type': 'CHOICE'},
                             'ProtocolEncrKey': {'type': 'SubjectPublicKeyInfo'},
                             'RegToken': {'type': 'UTF8String'},
                             'SinglePubInfo': {'members': [{'name': 'pubMethod',
                                                            'optional': False,
                                                            'type': 'INTEGER'},
                                                           {'name': 'pubLocation',
                                                            'optional': True,
                                                            'type': 'GeneralName'}],
                                               'type': 'SEQUENCE'},
                             'SubsequentMessage': {'type': 'INTEGER'},
                             'UTF8Pairs': {'type': 'UTF8String'}},
                   'values': {'id-ct': {'type': 'OBJECT IDENTIFIER',
                                        'value': ['id-smime', 1]},
                              'id-ct-encKeyWithID': {'type': 'OBJECT IDENTIFIER',
                                                     'value': ['id-ct', 21]},
                              'id-pkip': {'type': 'OBJECT IDENTIFIER',
                                          'value': ['id-pkix', 5]},
                              'id-pkix': {'type': 'OBJECT IDENTIFIER',
                                          'value': [('iso', 1),
                                                    ('identified-organization',
                                                     3),
                                                    ('dod', 6),
                                                    ('internet', 1),
                                                    ('security', 5),
                                                    ('mechanisms', 5),
                                                    7]},
                              'id-regCtrl': {'type': 'OBJECT IDENTIFIER',
                                             'value': ['id-pkip', 1]},
                              'id-regCtrl-authenticator': {'type': 'OBJECT IDENTIFIER',
                                                           'value': ['id-regCtrl',
                                                                     2]},
                              'id-regCtrl-oldCertID': {'type': 'OBJECT IDENTIFIER',
                                                       'value': ['id-regCtrl',
                                                                 5]},
                              'id-regCtrl-pkiArchiveOptions': {'type': 'OBJECT IDENTIFIER',
                                                               'value': ['id-regCtrl',
                                                                         4]},
                              'id-regCtrl-pkiPublicationInfo': {'type': 'OBJECT IDENTIFIER',
                                                                'value': ['id-regCtrl',
                                                                          3]},
                              'id-regCtrl-protocolEncrKey': {'type': 'OBJECT IDENTIFIER',
                                                             'value': ['id-regCtrl',
                                                                       6]},
                              'id-regCtrl-regToken': {'type': 'OBJECT IDENTIFIER',
                                                      'value': ['id-regCtrl',
                                                                1]},
                              'id-regInfo': {'type': 'OBJECT IDENTIFIER',
                                             'value': ['id-pkip', 2]},
                              'id-regInfo-certReq': {'type': 'OBJECT IDENTIFIER',
                                                     'value': ['id-regInfo',
                                                               2]},
                              'id-regInfo-utf8Pairs': {'type': 'OBJECT IDENTIFIER',
                                                       'value': ['id-regInfo',
                                                                 1]},
                              'id-smime': {'type': 'OBJECT IDENTIFIER',
                                           'value': [('iso', 1),
                                                     ('member-body', 2),
                                                     ('us', 840),
                                                     ('rsadsi', 113549),
                                                     ('pkcs', 1),
                                                     ('pkcs9', 9),
                                                     16]}}}}
